use std::ops::Range;
/// Renvoie true si les deux plages se chevauchent.
///
///     assert_eq!(plages::chevaucher(0..7, 3..10), true);
///     assert_eq!(plages::chevaucher(1..5, 101..105), false);
///
/// Pas de chevauchement si une des plages est vide.
///
///     assert_eq!(plages::chevaucher(0..0, 0..10), false);
///
pub fn chevaucher(r1: Range<usize>, r2: Range<usize>) -> bool {
r1.start < r1.end && r2.start < r2.end &&
r1.start < r2.end && r2.start < r1.end
}

