mod git;

extern crate libc;

fn main() {
    let path = std::env::args_os().skip(1).next()
        .expect("usage: libgit2-rs CHEMIN");

    let repo = git::Repository::open(&path)
        .expect("Ouverture du référentiel");

    let commit_oid = repo.reference_name_to_id("HEAD")
        .expect("Recherche de référence 'HEAD'");

    let commit = repo.find_commit(&commit_oid)
        .expect("Recherche de commit");

    let author = commit.author();
    println!("{} <{}>\n",
             author.name().unwrap_or("(none)"),
             author.email().unwrap_or("none"));

    println!("{}", commit.message().unwrap_or("(none)"));
}
